/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.gruppe.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="POLITISCHE_GRUPPE.UK",
     query="SELECT o FROM PolitischeGruppe o WHERE "

                         + "o"
                +".schluessel"
              +" = ?1"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?2"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?3"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?5"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?6"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="POLITISCHE_GRUPPE.WahlAndGruppeArten",
     query="SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 AND gruppe.gruppeArt IN (?2) ORDER BY gruppe.schluessel",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="POLITISCHE_GRUPPE.Wahl",
     query="SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 ORDER BY gruppe.schluessel",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="POLITISCHE_GRUPPE.WahlOrderByKurzname",
     query="SELECT gruppe FROM PolitischeGruppe gruppe WHERE gruppe.wahl = ?1 ORDER BY gruppe.kurzname",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "POLITISCHE_GRUPPE")
@javax.persistence.Cacheable
@javax.persistence.PrimaryKeyJoinColumn(name="gruppe_id")
@javax.persistence.DiscriminatorValue(PolitischeGruppe.DISCRIMINATOR_VALUE)

public
 class PolitischeGruppe
extends AbstractPolitischeGruppe
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "POLITISCHE_GRUPPE";

  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected PolitischeGruppe() {
    super();
  }
    public PolitischeGruppe(de.ivu.elect.jee.entity.customdata.CustomData customData){
        super(customData);
      }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public PolitischeGruppe(PolitischeGruppe original){
      original.copyEntity(this);
    }


  @Override
  public void resetAttributeChanged() {
        hasChangedMinderheit = false;
  
      hasChangedGehoertZu = false;
  

        
    super.resetAttributeChanged();
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "MINDERHEIT", nullable = PolitischeGruppeConstants.MINDERHEIT_NULLABLE)
    
  protected java.lang.Boolean minderheit =  false;

  @javax.persistence.Transient
  protected boolean hasChangedMinderheit = false;

  public boolean hasChangedMinderheit(){
    return hasChangedMinderheit;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertMinderheit = false;
     @javax.persistence.Transient
     private transient java.lang.Boolean wertNachLadenMinderheit;
  
  /**
   * 
   *
   * getter for POLITISCHE_GRUPPE.MINDERHEIT
   */
    @Override   public  java.lang.Boolean getMinderheit() {
        return minderheit;
      }

  /**
   * 
   *
   * setter for POLITISCHE_GRUPPE.MINDERHEIT
   *
   * @param minderheit
   */
  @Override   public void setMinderheit( java.lang.Boolean minderheit) {

       resetTkCache();
                  java.lang.Boolean minderheitInternal = minderheit;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.minderheit
      , minderheitInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedMinderheit |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("minderheit");
      }


             if (!isSeitLadenVeraendertMinderheit) {
          isSeitLadenVeraendertMinderheit = thisAttributChanged;
         if (isSeitLadenVeraendertMinderheit){
           wertNachLadenMinderheit=this.minderheit;
         }
       }
      

       this.minderheit = minderheitInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu GehoertZu
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GEHOERT_ZU_ID", referencedColumnName="GRUPPE_ID"))
  protected de.ivu.elect.business.gruppe.entity.Gruppenvereinigung gehoertZu;

  /**
   * 
   */
  @Override
  public void setGehoertZu(@javax.annotation.Nullable  de.ivu.elect.business.gruppe.entity.Gruppenvereinigung gehoertZu){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gehoertZu
    , gehoertZu);

    attributeChanged |= thisAttributChanged;

    hasChangedGehoertZu |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gehoertZu");
    }

    this.gehoertZu = gehoertZu;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.gruppe.entity.Gruppenvereinigung getGehoertZu(){
    return this.gehoertZu;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGehoertZu = false;

  public boolean hasChangedGehoertZu(){
    return hasChangedGehoertZu;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("PolitischeGruppe:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(PolitischeGruppe other){
        super.copyEntity(other);
                             other.minderheit = this.minderheit;
           
  other.setGehoertZu(this.getGehoertZu());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(PolitischeGruppe.class)){
        copyEntityAttributesUsingSetter((PolitischeGruppe) other.castTo(PolitischeGruppe.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von PolitischeGruppe: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(PolitischeGruppe other){
      super.copyEntityAttributesUsingSetter(other);
               other.setMinderheit(this.minderheit);
       
  }

    @Override
    public void copyEntityAttributesUsingSetter(de.ivu.elect.business.gruppe.entity.Gruppe other){
       if (other.isInstanceOf(PolitischeGruppe.class)) {
         copyEntityAttributesUsingSetter(other.castTo(PolitischeGruppe.class).getEntity());
       } else {
         super.copyEntityAttributesUsingSetter(other);
       }
    }

  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(PolitischeGruppe other){
       super.copyChangedEntityAttributesUsingSetter(other);
                       if (hasChangedMinderheit) {
        other.setMinderheit(this.minderheit);
      }
             }

    @Override
    public void copyChangedEntityAttributesUsingSetter(de.ivu.elect.business.gruppe.entity.Gruppe other){
      if (other.isInstanceOf(PolitischeGruppe.class)) {
        copyChangedEntityAttributesUsingSetter(other.castTo(PolitischeGruppe.class).getEntity());
      } else {
        super.copyChangedEntityAttributesUsingSetter(other);
      }
    }




    @javax.persistence.Transient
    private transient PolitischeGruppeTK tkCache;

    @Override
    protected void resetTkCache() {
    super.resetTkCache();
        tkCache = null;
    }

    public PolitischeGruppeTK getPolitischeGruppeTK(){
    if (tkCache==null) {
    tkCache = new PolitischeGruppeTK(

getSchluessel()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getPolitischeGruppeTK();
    }

  @Override
  public PolitischeGruppeUK getUk(){
    return getPolitischeGruppeUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return PolitischeGruppe.class;
  }

public PolitischeGruppeUK getPolitischeGruppeUK(){

   return  new PolitischeGruppeUK(

getSchluessel()
,     getWahl()==null?null:getWahl().getWahlUK()


  );
}

  @javax.persistence.Transient
  private transient PolitischeGruppeProperties properties;

  @Override
  public PolitischeGruppeProperties getProperties(){
    if (properties == null) {
      properties = new PolitischeGruppeProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public PolitischeGruppeProperties getPolitischeGruppeProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return PolitischeGruppeConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
        if (super.isAenderungenProtokollieren()){
      return true;
    }
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
            super.setProtokollierteAttributeMitWerten(werteVorher);
     
      if (werteVorher.containsKey(PolitischeGruppeConstants.MESSAGE_KEY_MINDERHEIT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(PolitischeGruppeConstants.MESSAGE_KEY_MINDERHEIT_EINZAHL);

        minderheit =
     vorher.getAttributTyp().getValueAsBoolean(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = super.getProtokollierteAttributeMitWerten();
                        if (isSeitLadenVeraendertMinderheit) {
      result.put(PolitischeGruppeConstants.MESSAGE_KEY_MINDERHEIT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.BOOLEAN
                , wertNachLadenMinderheit , minderheit));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
        super.resetProtokollierteAttribute();
                      isSeitLadenVeraendertMinderheit = false;
      wertNachLadenMinderheit = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
           java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = super.getFachlichAbhaengigeEntitaeten();
                    return result;
  }

        
            @Override
            protected String getInitialDiscriminator() {
              return "POLITISCHE_GRUPPE";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  @Override
  public boolean isPersistent() {
    return getId() != null;
  }



            
                  @Override
                public void resetValidation() {
                  super.resetValidation();
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                          @Override
                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                  validationResult.addAll(super.validateEntity());
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(minderheit, this, PolitischeGruppeConstants.MESSAGE_KEY_MINDERHEIT_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            }
